/*=======================================================================*/
/*  q_cutfits                                                            */
/*     FITSǡڤФ˳⤹                            */
/*=======================================================================*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<q_lib.h>
/*=======================================================================*/
void print_usage(char *);
int check_command_line(int,char **,char **,char **,double *,double *,
                       int *,int *,int *,double *);
/*=======================================================================*/
void print_usage(char *s)
{
char *ss;

  ss=strip_name(s);
  fprintf(stdout,
"NAME\n"
"       %s - Extract FITS image around the center and expand image.\n\n"
"SYNOPSIS\n"
"       q_cutfits input_file cx cy nx ny expand bad_val out_file\n\n"
"DESCRIPTION\n"
"       q_cutfits extract image from the input image. Extarcted area is\n"
"       centerd at cx,cy in original image and output number of pixels is\n"
"       nx*2,ny*2. The output image is expanded by the factor expand.\n"
"       If the original pixel position is out of the input image,\n"
"       bad_val is used for the output pixel value\n"
"       cx and cy should be real value, and expand is integer.\n"
"       cx*expand and cy*expand should be integer.\n\n"
,ss);
}
/*=======================================================================*/
int main(int argc, char ** argv)
{
char *input_file,*output_file;
FITS_DATA ifits,ofits;
int nx,ny,e;
double cx,cy,bad_val;
int icx,icy;
char b[32];
int x,y,z,w,xx,yy;
double w1;
int status=0;
double *wbuf;

/* Check command line */
  if(check_command_line(argc,argv,&input_file,&output_file,&cx,&cy,&nx,&ny,&e,&bad_val)!=0){
    fprintf(stdout,"Error @ check_command_line\n");exit(1);}
/* cx,cy  1ϤޤindexʤΤ */
  sprintf(b,"%.0f %.0f",(cx-1.0)*e,(cy-1.0)*e);
  sscanf(b,"%d %d",&icx,&icy);

/* Open input file and out put files */
  if(openfits(&ifits,input_file)!=0){ exit(1); }
  if(prep_readfits(&ifits)!=0){ exit(1); }
  if(createfits(&ofits,output_file)!=0){ exit(1); }

/* Make new data type */
  ofits.bp = DOUBLE_IMG ;
  ofits.nax=ifits.nax ;
  ofits.naxes[2]=ifits.naxes[2]; ofits.naxes[3]=ifits.naxes[3];
  ofits.naxes[0]=nx*2 ; ofits.naxes[1]=ny*2;

/* Allocate memory for data */
  if(alloc_memory_for_data(&ofits)!=0) exit(1);

/* Write header  إå¤˻Ĥƽ񤭼̤ */
  if(convert_all_head(&ifits,&ofits)!=0) exit(1);

/* Working Area */
  wbuf = (double *)malloc(ifits.naxes[0]*e*ifits.naxes[1]*e*sizeof(double));
  if(wbuf==NULL){fprintf(stdout,"malloc error\n");exit(1);}

/* Calcuration */
  for(w=1;w<=ifits.naxes[3];++w){
  for(z=1;z<=ifits.naxes[2];++z){
    if(read_2d_data(&ifits,z,w)!=0){exit(1);}
    /* expand */
    for(y=0;y<ifits.naxes[1];++y){
    for(x=0;x<ifits.naxes[0];++x){
      w1 = d_data(&ifits,x,y);
      w1 = w1 / (double)e / (double)e ;
      for(yy=0;yy<e;++yy){
      for(xx=0;xx<e;++xx){
       wbuf[(x*e+xx)+(y*e+yy)*ifits.naxes[0]*e] = w1 ;
      }}
    }}
   /* cut */
    for(y=0;y<ofits.naxes[1];++y){
    for(x=0;x<ofits.naxes[0];++x){
      yy = icy + y +5 - ny ;
      xx = icx + x +5 - nx ;
      if( xx<0 || yy<0 || xx >= ifits.naxes[0]*e || yy >= ifits.naxes[1]*e ){
        ((double *)ofits.data)[x+y*ofits.naxes[0]]=bad_val;/* ̵ */
      }else {
        ((double *)ofits.data)[x+y*ofits.naxes[0]]=
           wbuf[(xx)+(yy)*ifits.naxes[0]*e] ;
      }
    }}
    if(write_2d_data(&ofits,z,w)!=0){exit(1);}
  }}

/* Close */
  fits_close_file(ifits.fp,&status);
  fits_close_file(ofits.fp,&status);

  exit(0);
}
/*=======================================================================*/
int check_command_line(int argc,char ** argv ,char ** input_file,
                       char ** output_file,double *cx,double *cy,
                       int *nx,int *ny,int *expand,double *bad_val)
{
  if(argc!=9 ){
    print_usage(argv[0]); return(1);}

  *input_file = argv[1] ;
  *output_file = argv[8] ;
  sscanf(argv[2],"%lf",cx); sscanf(argv[3],"%lf",cy);
  sscanf(argv[4],"%d",nx); sscanf(argv[5],"%d",ny);
  sscanf(argv[6],"%d",expand); sscanf(argv[7],"%lf",bad_val);

  set_cmd_hist(argc,argv);
  return(0);
}
