/*=======================================================================*/
/*  q_expand                                                             */
/*     FITSǡĥ̾                                        */
/*=======================================================================*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<q_lib.h>
/*=======================================================================*/
void print_usage(char *);
int check_command_line(int,char **,char **,char **,int *);
/*=======================================================================*/
void print_usage(char *s)
{
char *ss;

  ss=strip_name(s);
  fprintf(stdout,
"NAME\n"
"       %s - Expand/reduce pixel scale of FIT image.\n\n"
"SYNOPSIS\n"
"       q_expand input_file n output_file\n\n"
"DESCRIPTION\n"
"       q_expand expands or reduce the size of pixel of FITS image.\n\n"
"       In case n > 0,  number of pixels in X and Y axis are multiplied by n.\n"
"       One pixel is divided into n x n pixels and the value is multiplied"
"       by 1/n/n to keep the total flux.\n"
"       In case n < 0, (-n) x (-n) pixels are summed up into one pixel.\n"
"       In this case, (-n) should be a divisor of original number of pixels.\n\n"
,ss);
}
/*=======================================================================*/
int main(int argc, char ** argv)
{
char *input_file,*output_file;
FITS_DATA ifits,ofits;
int n;
int x,y,z,w,xx,yy;
double w1;
int status=0;

/* Check command line */
  if(check_command_line(argc,argv,&input_file,&output_file,&n)!=0){
    fprintf(stdout,"Error @ check_command_line\n");exit(1);}

/* Open input file and out put files */
  if(openfits(&ifits,input_file)!=0){ exit(1); }
  if(prep_readfits(&ifits)!=0){ exit(1); }
  if(createfits(&ofits,output_file)!=0){ exit(1); }

/* Make new data type */
  ofits.bp = DOUBLE_IMG ;
  ofits.nax=ifits.nax ;
  ofits.naxes[2]=ifits.naxes[2]; ofits.naxes[3]=ifits.naxes[3];
  if(n>0){
    ofits.naxes[0]=ifits.naxes[0]*n; ofits.naxes[1]=ifits.naxes[1]*n;
  }else if(n<0){
    ofits.naxes[0]=ifits.naxes[0]/(-n);ofits.naxes[1]=ifits.naxes[1]/(-n);
  }else {
    fprintf(stdout,"Error number=%d\n",n); exit(1) ;
  }

/* Allocate memory for data */
  if(alloc_memory_for_data(&ofits)!=0) exit(1);

/* Write header  إå¤˻Ĥƽ񤭼̤ */
  if(convert_all_head(&ifits,&ofits)!=0) exit(1);

/* Calcuration */
  for(w=1;w<=ifits.naxes[3];++w){
  for(z=1;z<=ifits.naxes[2];++z){
    if(read_2d_data(&ifits,z,w)!=0){exit(1);}
    if(n>0){
      for(y=0;y<ifits.naxes[1];++y){
      for(x=0;x<ifits.naxes[0];++x){
        w1 = d_data(&ifits,x,y);
        w1 = w1 / (double)n / (double)n ;
        for(yy=0;yy<n;++yy){
        for(xx=0;xx<n;++xx){
         ((double *)ofits.data)[(x*n+xx)+(y*n+yy)*ofits.naxes[0]] = w1 ;
        }}
      }}
    }else{
      for(y=0;y<ofits.naxes[1];++y){
      for(x=0;x<ofits.naxes[0];++x){
        w1 = 0.0 ;
        for(yy=0;yy<-n;++yy){
        for(xx=0;xx<-n;++xx){
          w1 += d_data(&ifits,x*(-n)+xx,y*(-n)+yy);
        }}
        ((double *)ofits.data)[x+y*ofits.naxes[0]] = w1 ;
      }}
    }
    if(write_2d_data(&ofits,z,w)!=0){exit(1);}
  }}

/* Close */
  fits_close_file(ifits.fp,&status);
  fits_close_file(ofits.fp,&status);

  exit(0);
}
/*=======================================================================*/
int check_command_line(int argc,char ** argv ,char ** input_file,
                       char ** output_file,int *number)
{
  if(argc!=4 ){
    print_usage(argv[0]); return(1);}

  *input_file = argv[1] ;
  *output_file = argv[3] ;
  sscanf(argv[2],"%d",number);

  set_cmd_hist(argc,argv);
  return(0);
}
