/*=======================================================================*/
/*  q_head                                                               */
/*     FITSǡΥإåꥭɤΥǡФ          */
/*=======================================================================*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<q_lib.h>
/*=======================================================================*/
void print_usage(char *);
int check_command_line(int,char **,char **, char **);
/*=======================================================================*/
void print_usage(char *s)
{
char *ss;

  ss=strip_name(s);
  fprintf(stdout,
"NAME\n"
"       %s - Read value at key_word in FITS Header\n\n"
"SYNOPSIS\n"
"       %s input_file key_word\n\n"
"DESCRIPTION\n"
"       %s reads FITS heade record and output the value at key_word\n\n"
,ss,ss,ss);
}
/*=======================================================================*/
int main(int argc, char ** argv)
{
char *input_file,*key_word;
FITS_DATA ifits;
int status=0;
char val[FLEN_CARD];

/* Check command line */
  if(check_command_line(argc,argv,&input_file,&key_word)!=0){
    fprintf(stdout,"Error @ check_command_line\n");exit(1);}

/* Open */
  if(openfits(&ifits,input_file)!=0){ exit(1); }

/* Read and find the value */
  if(q_head(ifits.fp,key_word,val)!=0){
    fprintf(stdout,"Error @ q_head\n");
    exit(1);
  }

/* Output */
  printf("%s\n",val);

/* By */
  fits_close_file(ifits.fp,&status);

  exit(0);
}
/*=======================================================================*/
int check_command_line(int argc,char ** argv ,char ** fname_1, char ** kw)
{
  if(argc==1){/* This is normal usage query  */
     print_usage(argv[0]);exit(0);}

  if(argc!=3 ){
    print_usage(argv[0]); return(1);}

  *fname_1 = argv[1] ;
  *kw      = argv[2] ;
  return(0);
}
