/*=======================================================================*/
/* Library headers for q_****                                            */
/*=======================================================================*/
#include<stdint.h>    
#include<inttypes.h>
#include<fitsio.h>

/* FITSǡ򰷤ι¤                                    */
typedef struct {
  int  nax;                      /* NAXIS                              */
  long naxes[4];                 /* NAXIS1..4                          */
  int  bp;                       /* BITPIX                             */
  int  datatype;                 /* DTYPE                              */
  long srt;                      /* SORT  0:not yet  1: Done           */
  void *data;                    /* fits data                          */
  fitsfile *fp;                  /* fitsfile                           */
} FITS_DATA ; 

/* ΰι¤ */
typedef struct {
  int w0; int w1 ; int wr ;
  int x0; int x1 ; int xr ;
  int y0; int y1 ; int yr ;
  int z0; int z1 ; int zr ;
  int cntl ;
} REGION ;
/* ɸΥѥ᡼Ѥͤ                                          */
#define REG_POINT  1
#define REG_REGION 2
#define REG_LIST   3
#define REG_VECTOR 4
#define REG_MAX  999999
#define REG_MIN -999999
/* ưȥѥѥ᡼                                          */
#define PLOT_ON    1 
#define PLOT_OFF   0
#define OUT_STDOUT 2
#define OUT_FITS_1 4
#define OUT_FITS_2 8
#define XFC_PLOT_GIF   16
#define XFC_PLOT_PS    64

#define XFC_GIF_FILE "qplot.gif"
#define XFC_PS_FILE "qplot.ps"

#define FCONV_AVE 1
#define FCONV_SIG 2
#define FCONV_MED 4
#define FCONV_WTE 8

#define SQR(x) ((x)*(x))

#define MAXHIST 1024
char cmd_hist[MAXHIST] ;

/* q_list_stat  x,y,z1ˤꥹ                         */
int q_list_stat_1list(FITS_DATA *,REGION *,int **,double **,int *); 
/* ΰϸ塢ͤ䴰                                                */
int set_region(REGION *, FITS_DATA *);
/* 3ǡפˤ2ǡ */
int q_stat(FITS_DATA *,FITS_DATA *,FITS_DATA *,REGION *,int,FITS_DATA *,double);
/* ɸϰϤβ                                                  */
void region_input(char *,int *,int *,int *);
/* FITSΥإå                                                */
int write_head_img(FITS_DATA *);
/* 2̥ǡ֤ͤ                                               */
double d_data(FITS_DATA *d,int, int );
/* 2̥ǡ֤ͤ                                               */
int32_t int32_data(FITS_DATA *d,int, int );
int64_t int64_data(FITS_DATA *d,int, int );
/* 2̤Υǡ                                               */
int write_2d_data(FITS_DATA *,int,int);
/* 2̤Υǡɤ                                               */
int read_2d_data(FITS_DATA *,int,int);
/* FITSǡإå򻲾ȥեΤΤ¤˻Ĥƽ񤭼̤        */
int convert_all_head(FITS_DATA *, FITS_DATA *);
int convert_int_head(FITS_DATA *, FITS_DATA *,char *,char *,int);
int convert_long_head(FITS_DATA *, FITS_DATA *,char *,char *,long);
/* FITSɤ߽Ф                                                  */
int prep_readfits(FITS_DATA *);
/* FITSǡΤΥդ 21ʬ                   */
int alloc_memory_for_data(FITS_DATA *);
/* ʬַ׻                                                          */
int clkreduc(double *, double *, double *, int ,int ,int ,int ,int ,int ,int ,
                int ,int ,char *) ;
/* åطξɤ߽Ф                                          */
int clkhead(fitsfile *,int *,int *,int *,int *,
         int *, int *, int *,int *,int *,int *);
/* FITSեΥإåꥭɤбͤɤ߽Ф      */
int q_head_int(fitsfile *,char *,int *);
/* FITSեΥإåꥭɤбͤʸɤ߽Ф  */
int q_head(fitsfile *,char *,char *);
/* FITSե                                                    */
int createfits(FITS_DATA *,char *);
/* FITSե򳫤                                                    */
int openfits(FITS_DATA *,char *);
/* ꥹȥեǻꤵ줿ˡꥹȥեɤ          */
int read_list(char *,char ***);
/* ޥɥ饤ε                                              */
void set_cmd_hist(int ,char ** );
/* եѥե̾ѥ                                      */
char *strip_name(char * );
/* ʸ󤫤ζȤΤ                                      */
char *strip_space(char * );
