/*=======================================================================*/
/*  q_minmax                                                             */
/*     ǾΥԥ                                              */
/*=======================================================================*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<q_lib.h>
/*=======================================================================*/
void print_usage(char *);
int check_command_line(int,char **,char **,REGION *);
int q_minmax(FITS_DATA *,REGION *);
/*=======================================================================*/
void print_usage(char *s)
{
char *ss;

  ss=strip_name(s);
  fprintf(stdout,
"NAME\n"
"       q_minmax  - ǡζΰǾͤ\n\n"
"SYNOPSIS\n"
"       q_minmax ifile w_region x_region y_region z_region\n\n"
"DESCRIPTION\n"
"       q_minmax  ifile Ϳ줿եλꤵ줿ΰ\n"
"       ͤȺǾͤ𤹤ΤǤ\n\n"
"       ΰꤹΤ˰ʲΤ褦ˡѤޤ\n"
"       x_region, y_region, z_region, w_region Ϳ\n"
"       ñ˰ĤΡֿפ񤯤ʤ ͤꤷȤˤʤꡢ\n"
"       ֿ:פȽ񤯤ȡο򲼸¤Ⱦ¤ȤϰϤ\n"
"       Ȥˤʤޤ\n"
"       q_minmaxǤϡֿ-פȽ񤯥ꥹȻϵޤ\n\n"
"       ޤֿ:פξˤϺ()οά뤳Ȥǽ\n"
"       ξˤϲեǤȤꤦͤκǾ()ͤͿȤ\n"
"       ʤޤ\n\n"
"       ޤ(κɸ)1ޤǤͤޤ\n\n"
"       w_regionϺɸwдֹ̣ȤȤϰϻ\n"
"       򤹤뤳Ȥϰ̣ޤ󡣤Ǥμϰϻ򤷤Ƥ\n"
"       ޤͤǻꤷʤФʤޤ\n\n"
);

}
/*=======================================================================*/
int main(int argc, char ** argv)
{
char *ifile;
FITS_DATA fits;
REGION reg;
int status=0;
int x,y,z,w,k,min_x,max_x,min_y,max_y,min_z,max_z;
double min,max;

/* Check command line */
  if(check_command_line(argc,argv,&ifile,&reg)!=0){
    fprintf(stdout,"Error @ check_command_line\n");exit(1);}

/* Open input file  */
  if(openfits(&fits,ifile)!=0){ exit(1); }

/* Read header of the input file  */
  if(prep_readfits(&fits)!=0){ exit(1); }

/* Set region */
  if(set_region(&reg,&fits)!=0) { exit(1); }

  /* 4ǻꤻ */
  if(reg.wr!=REG_POINT) {
    fprintf(stdout,"w_region error - w_region must be a point \n");
    return(-1);
  }
  /* ¾μϰϤǻꤻ */
  if(reg.xr==REG_LIST) {
    fprintf(stdout,"x_region error - x_region must be a point or region\n");
    return(-1);
  }
  if(reg.yr==REG_LIST) {
    fprintf(stdout,"y_region error - y_region must be a point or region\n");
    return(-1);
  }
  if(reg.zr==REG_LIST) {
    fprintf(stdout,"z_region error - z_region must be a point or region\n");
    return(-1);
  }

/* Calcuration */
  k=0;min=max=0.0;min_x=max_x=min_y=max_y=min_z=max_z=0;
  for(w=reg.w0;w<=reg.w1;++w) {
  for(z=reg.z0;z<=reg.z1;++z) {
    if(read_2d_data(&fits,z,w)!=0) {exit(1);}
    for(y=reg.y0-1;y<=reg.y1-1;++y){
    for(x=reg.x0-1;x<=reg.x1-1;++x){
      if(k==0) {
        min=d_data(&fits,x,y);min_x=x;min_y=y;min_z=z;
        max=d_data(&fits,x,y);max_x=x;max_y=y;max_z=z;
      }
      if(min>d_data(&fits,x,y)) {
        min=d_data(&fits,x,y);min_x=x;min_y=y;min_z=z;
      }
      if(max<d_data(&fits,x,y)) {
        max=d_data(&fits,x,y);max_x=x;max_y=y;max_z=z;
      }
      k++;  
    }}
  }}

  fprintf(stdout,"min= %e ( %d %d %d ) max= %e ( %d %d %d )\n",
                  min,min_x+1,min_y+1,min_z,max,max_x+1,max_y+1,max_z);

/* Close */
  fits_close_file(fits.fp,&status);
  exit(0);
}
/*=======================================================================*/
int check_command_line(int argc,char ** argv ,char ** ifile,
                       REGION * reg)
{
  if(argc==1){/* This is normal usage query  */
     print_usage(argv[0]);exit(0);}

  if(argc!=6 && argc!=7 ) { print_usage(argv[0]);return(1); }
   // argc ==7 is OK for compatibility

/* ϥե̾ */
  *ifile=argv[1];

/* ޤд򼨤ɸwɤ߼ */
  region_input(argv[2],&(reg->w0),&(reg->w1),&(reg->wr));
/* ơx,y,zɸɤ߼ */
  region_input(argv[3],&(reg->x0),&(reg->x1),&(reg->xr));
  region_input(argv[4],&(reg->y0),&(reg->y1),&(reg->yr));
  region_input(argv[5],&(reg->z0),&(reg->z1),&(reg->zr));

  return(0);
}
