/*=======================================================================*/
/*  q_skyfit                                                             */
/*     Хå饦ɥѥաꥧեå                    */
/*=======================================================================*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<q_lib.h>
#include<gsl/gsl_vector.h>  // ٥ȥ
#include<gsl/gsl_matrix.h>  // 
#include<gsl/gsl_blas.h>    // 
#include<gsl/gsl_linalg.h>  // չ
/*=======================================================================*/
void print_usage(char *);
int check_command_line(int,char **,char **,char **,REGION *,double *,
                       double *,double *,int *,double *);
void solve_axb(gsl_matrix *,gsl_vector *, gsl_matrix *, gsl_vector *);
double Fun(int i, int x, int y, double , int *, int *);
/*=======================================================================*/
void print_usage(char *s)
{
char *ss;

  ss=strip_name(s);
  fprintf(stdout,
"NAME\n"
"      %s - fit back ground pattern with Fourier series.\n\n"
"SYNOPSIS\n"
"      %s input_file w_region x_region y_region z_region cx cy r\134\n"
"      n L fitted_sky_file\n\n"
"DESCRIPTION\n"
"      %s estimate back ground pattern with Fourier series.\n"
"      Rectangle area specified by command line, except area within a\n"
"      circle centerd at cx,cy and radious r, is used as an input data.\n"
"      Maximum order of Fourier series is n. L is the size of total area.\n"
"      Fitting formula:\n"
"       W(x,y) =  W0 + W1*x + W2*y\n"
"                Wc(j,k)*cos(2(j*x+ky)/L) + Ws(j,k)*sin(2(j*x+ky)/L)\n"
"      here, W(x,y) is the estimated pattern.  takes sum wihtin j>=0\n"
"      and j*j+k*k<=n.\n"
"      w_region and z_region should be list(w0-w1) or point(w).\n"
"      x_region and y_region should be list.\n"
"      Output image W(x,y) has the same size of X/Y with the input image\n"
"      in spite of the x/y_region that is used to restrict the area for fit\n"
,ss,ss,ss);
}
/*=======================================================================*/
int main(int argc, char ** argv)
{
char *fits_file,*fitted_sky;
FITS_DATA fits;
FITS_DATA sky;
REGION reg;
int status=0;
double cx,cy,r,L;  // 򥨥ꥢ濴Ⱦ¡ΰ襵
int n;             // 
int j,k,m,i,h;
gsl_matrix *Q,*Qi ;
gsl_vector *A,*B ;
int *a,*b;
int z,w,x,y;
double rr,ww;

/* Check command line */
  if(check_command_line(argc,argv,&fits_file,&fitted_sky,&reg,&cx,&cy,&r,&n,&L)
          !=0){
    fprintf(stdout,"Error @ check_command_line\n");exit(1);}

/* Open input file */
  if(openfits(&fits,fits_file)!=0){ exit(1); }
  if(prep_readfits(&fits)!=0){ exit(1); }
  if(set_region(&reg,&fits)!=0) { exit(1); }

/* ƽФΥå */
  /* 3,4ϰϻϥ */
  if(reg.wr==REG_REGION){
    fprintf(stdout,"w_region error - w_region must be a point or list \n");
    exit(1);
  }
  if(reg.zr==REG_REGION){
    fprintf(stdout,"z_region error - z_region must be a point or list \n");
    exit(1);
  }
  /* x,yꥹȤǤ뤳 */
  if(!((reg.xr==REG_LIST)&&(reg.yr==REG_LIST)) ){
    fprintf(stdout,"x,y must be list\n"); exit(1);}

/* Open output */
  if(createfits(&sky,fitted_sky)!=0){ exit(1); }
  sky.bp = DOUBLE_IMG ; sky.nax=fits.nax;
  sky.naxes[0]=fits.naxes[0]      ; sky.naxes[1]=fits.naxes[1]      ;
  sky.naxes[2]=reg.z1 - reg.z0 + 1; sky.naxes[3]=reg.w1 - reg.w0 + 1;
  if(alloc_memory_for_data(&sky)!=0) { exit(1); }
  if(write_head_img(&sky)!=0){ exit(1); }

/* եåȼ
    ΰ礭 Lx=Ly=L Ȥ
       W = W0 + W1*x + W2*y 
          + Wc(j,k)*cos(2(j*x+k*y)/L) + Ws(j,k)*sin(2(j*x+k*y)/L) 
         j>=0  j*j+k*k<=n ǤȤ롣
     m ŬˤȤä
             m
       W  =  A(i)*Fun(i,x,y)
            i=0
    Ƚ񤭴롣
    Τ褦˽񴹤Ƥ
    ĺ
     S = xy ( W  - Wobs)^2
     S/2 = xy ( i A(i)*Fun(i,x,y) - Wobs )
                 *( h Fun(h,x,y)*A(h) )
     ä
        xyi A(i)*Fun(i,x,y)*Fun(h,x,y) = xy Wobs*Fun(h,x,y)
                                                        for all h
        Q(h,i) = xy Fun(h,x,y)*Fun(i,x,y)
        B(h) = xy Wobs*Fun(h,x,y)
     Ȥ
        i  Q(h,i)  A(i) = B(h) 
     ȤʤΤ Qεչ InvQ  A = InvQ B Ȥ Aޤ롣 */
/* Ȥ m  */
  m=3;
  for(j=0;j<=n;++j){   // jο˸
  for(k=-n;k<=n;++k){  
  if(j*j+k*k<=n*n && !(j==0&&k<=0)){
    m++;m++;
  }}}
/* ΰγ */
  Q=gsl_matrix_alloc(m,m);
  Qi=gsl_matrix_alloc(m,m);
  A=gsl_vector_alloc(m);
  B=gsl_vector_alloc(m);
  a = (int *)calloc(m,sizeof(int)); // i  j,k Ѵ
  b = (int *)calloc(m,sizeof(int)); // i  j,k Ѵ
  i=3;
  for(j=0;j<=n;++j){   // jο˸
  for(k=-n;k<=n;++k){  // 
  if(j*j+k*k<=n*n && !(j==0&&k<=0)){
    a[i] = j; b[i] = k;
    a[i+1] = j; b[i+1] = k;
    ++i;++i;
  }}}

  for(w=reg.w0;w<=reg.w1;++w){
  for(z=reg.z0;z<=reg.z1;++z){
    if(read_2d_data(&fits,z,w)!=0) exit(1); // ǡɤ߹
   /*  Q  ٥ȥ B ν */
    for(k=0;k<m;++k){
      B->data[k]=0.0;
      for(h=0;h<m;++h){ Q->data[k*Q->tda+h] = 0.0 ; }
    }
   /* xy Υ롼(1) */
    for(y=reg.y0-1;y<=reg.y1-1;++y){
    for(x=reg.x0-1;x<=reg.x1-1;++x){
     /* 1ϤޤΥޥɥ饤0ϤޤؿȤΰ㤤 
        ˤΰ */
     rr = SQR(x-(cx-1.0))+SQR(y-(cy-1.0));
     if(rr>SQR(r)){
       //  Q(k,i) = xy Fun(k,x,y)*Fun(i,x,y)
       //  B(k) = xy Wobs*Fun(k,x,y)
       ww = d_data(&fits, x, y);
       for(k=0;k<m;++k){
         B->data[k] =  B->data[k] + ww * Fun(k,x,y,L,a,b) ;
         for(i=0;i<m;++i){
           Q->data[k*Q->tda+i] = Q->data[k*Q->tda+i] 
                                + Fun(k,x,y,L,a,b)*Fun(i,x,y,L,a,b);
         }
       }
     }
    }} /* xy 롼(1) */
    solve_axb(Q,B,Qi,A);
   /* եåȷ̤κ  */
   for(y=0;y<fits.naxes[1];++y){
   for(x=0;x<fits.naxes[0];++x){
     ww = 0.0 ;
     for(k=0;k<m;++k){
       ww = ww + A->data[k]* Fun(k,x,y,L,a,b);
     }
     ((double *)sky.data)[x+y*sky.naxes[0]] = ww ;
   }} /* x y loop2 */
   if(write_2d_data(&sky,z-reg.z0+1,w-reg.w0+1)!=0){ exit(-1); }
  }}

  fits_close_file(fits.fp,&status);
  fits_close_file(sky.fp,&status);
  exit(0);
}
/*=======================================================================*/
double Fun(int i, int x, int y, double L, int *a, int *b)
{
double z,w;

  if(i==0) { 
    z=1.0;
  }else if(i==1){
    z = (double)x ;
  }else if(i==2){
    z = (double)y ;
  }else if(i%2==1){
    w = (double)a[i]*(double)x + (double)b[i]*(double)y ;
    z = cos(2*M_PI*w/L) ;
  }else {
    w = (double)a[i]*(double)x + (double)b[i]*(double)y ;
    z = sin(2*M_PI*w/L) ;
  }
  return(z);
}
/*=======================================================================*/
/* A x = b 򤤤 invA  x  */
void solve_axb(gsl_matrix *A,gsl_vector *b, gsl_matrix *invA, gsl_vector *x)
{
gsl_matrix *LU;
gsl_permutation *p;
int signum;

/* ΰγ */
  LU = gsl_matrix_alloc(A->size1,A->size2);
  p=gsl_permutation_alloc(A->size1);

/* LUʬ */
  gsl_matrix_memcpy(LU,A);
  gsl_linalg_LU_decomp(LU,p,&signum);

/* LUʬ򤫤 Ax=b  */
  gsl_linalg_LU_solve(LU,p,b,x);

/* LUʬ򤫤Aεչ׻ */
  gsl_linalg_LU_invert(LU,p,invA);

/* ΰγ */
  gsl_permutation_free(p);
  gsl_matrix_free(LU);

}
/*=======================================================================*/
int check_command_line(int argc,char ** argv ,char ** fits_file,
                       char ** fitted_sky, REGION * reg ,
                       double *cx,double *cy,double *r,int *n,double *L)
{
  if(argc==1){/* This is normal usage query  */
     print_usage(argv[0]);exit(0);}
  if(argc!=12){print_usage(argv[0]);exit(1);}
 
/* ϥե̾ */
  *fits_file=argv[1];
  *fitted_sky=argv[11] ;

/* ޤд򼨤ɸwɤ߼ */
  region_input(argv[2],&(reg->w0),&(reg->w1),&(reg->wr));
/* ơx,y,zɸɤ߼ */
  region_input(argv[3],&(reg->x0),&(reg->x1),&(reg->xr));
  region_input(argv[4],&(reg->y0),&(reg->y1),&(reg->yr));
  region_input(argv[5],&(reg->z0),&(reg->z1),&(reg->zr));

/* 򥨥ꥢ濴Ⱦ */
  sscanf(argv[6],"%lf",cx);
  sscanf(argv[7],"%lf",cy);
  sscanf(argv[8],"%lf",r);

/* ΰ襵 */
  sscanf(argv[9],"%d",n);
  sscanf(argv[10],"%lf",L);

  set_cmd_hist(argc,argv);

  return(0);
}
