/*=======================================================================*/
/*  q_startrace                                                          */
/*     ڥȥǡȥ졼                                */
/*=======================================================================*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<q_lib.h>
/*=======================================================================*/
/*   ¤Τ                                                        */
typedef struct {
   double n;     /* gaussian's normalozation factor */
   double m;     /* gaussian's center */
   double sigma; /* gaussian's sigma */
   double a;     /* linear factor */
   double b;     /* linear bias */
} GAUSSIAN;
/*   y(x) = a*x + b + n*exp(-(x-m)*(x-m)/2/sigma/sigma ) */

/* ȥ饤 */
#define MAXTRY 1000000

/*=======================================================================*/
void print_usage(char *);
int check_command_line(int,char **,char **,REGION*);
void fit_gaussian(double *, int , GAUSSIAN *,int);

double zansa_gaus(double *,int ,double ,double ,double ,double ,double );
double z_gaus1(double *,int ,
               double ,double ,double ,double ,double *,double );
double z_gaus2(double *,int ,
               double ,double ,double ,double *,double ,
               double *,double );
double z_gaus3(double *,int ,
               double ,double ,double *,double ,double *,double ,
               double *,double );
double z_gaus4(double *,int ,
               double ,double *,double ,double *,double ,
               double *,double ,double *,double );
double z_gaus5(double *,int ,
               double *,double ,double *,double ,double *,double ,
               double *,double ,double *,double );

int ntry = 0 ;
/*=======================================================================*/
void print_usage(char *s)
{
char *ss;

  ss=strip_name(s);
  fprintf(stdout,
"NAME\n"
"       %s - ڥȥǡȥ졼\n\n"
"SYNOPSIS\n"
"       %s fits_file w x_region y_region z\n\n"
"DESCRIPTION\n"
"       %s  fits_file Ϳ줿եڤäơ\n"
"       y_regionΥԡgaussian fitʤxפޤ\n"
"       å׺ɸβʤɤŬѤ뤳Ȥǡ\n"
"       ְΤ椬򤹤ΤѤޤ\n\n"
"       w,x_region,zϤ줾줳ΥեåȤԤϲϰϤꤷޤ\n"
"       ν񼰤Ǥ⡢ϰϻλq_list_statȤʤ񼰤˽\n"
"       ޤʤy,w,zϰxϰ(a-bη)Ǥɬפޤ\n\n"
"       y_regionǤϡԡ򸡽ФΥڥȥ뤬ƤyϰϤ\n"
"       ymin:ymaxȤǻꤷޤϰϤˤԡϤʤ\n"
"       ꤷƷ׻ޤ\n\n"
"       եåȤƤǥ뼰 yԥPͤλ\n"
"          P=A*y+B+N*exp(-(y-M)*(y-M)/2./S/S  \n"
"       ȤΤǤΥѥ᡼xФƵᡢɸϤ˽Ϥޤ\n\n"
"       SNȡ׻«ʤ⤷ޤ\n"
"       ץॽȤ߹ޤ줿MAXTRY¤򤳤\n"
"       xФ׻򤢤ƼxˤĤޤ\n\n"
,ss,ss,ss) ;
}
/*=======================================================================*/
int main(int argc, char ** argv)
{
char *ifile;
REGION reg;
FITS_DATA fits;
double *v;
int x,y,i;
GAUSSIAN fit;
GAUSSIAN meanfit;
int meanok;
int status=0;

/* Check command line */
  if(check_command_line(argc,argv,&ifile,&reg)!=0) {
    fprintf(stdout,"Error @ check_command_line\n");exit(1);}

/* Open input file */
  if(openfits(&fits,ifile)!=0){ exit(1); }
  if(prep_readfits(&fits)!=0){ exit(1); }
  if(set_region(&reg,&fits)!=0) { exit(1); }

  if((v = (double *)malloc(sizeof(double)*(reg.y1-reg.y0+1)))==NULL){
    fprintf(stdout,"malloc error\n");exit(-1);}

/* Operation */
  if(read_2d_data(&fits,reg.z0,reg.w0)!=0) {exit(1);}

/* Step1  xˤĤʿѤƥեåȤͤˤƤޤ*/
  for(y=reg.y0-1;y<=reg.y1-1;++y) v[y-(reg.y0-1)] = 0.0 ;
  for(x=reg.x0-1;x<=reg.x1-1;++x){
    for(y=reg.y0-1;y<=reg.y1-1;++y) v[y-(reg.y0-1)] += d_data(&fits,x,y);
  }
  for(y=reg.y0-1;y<=reg.y1-1;++y) v[y-(reg.y0-1)] /= (double)(reg.x1-reg.x0+1);

  ntry = 0 ;
  fit_gaussian(v,reg.y1-reg.y0+1,&meanfit,0);
  if(ntry<MAXTRY) meanok = 1 ; else meanok=0 ;

/* Step2 ͤʬäƤˡȴƥեåȤ롣 */
  for(x=reg.x0-1;x<=reg.x1-1;++x){
     /* ǡȴ */
    for(y=reg.y0-1;y<=reg.y1-1;++y) v[y-(reg.y0-1)] = d_data(&fits,x,y);
     /* եå */
    ntry = 0 ;
    fit.a = meanfit.a ; fit.b = meanfit.b ;
    fit.n = meanfit.n ; fit.m = meanfit.m ;
    fit.sigma = meanfit.sigma ;
    fit_gaussian(v,reg.y1-reg.y0+1,&fit,meanok);
     /* ̤ν */
/*  printf("P=A*y+B+N*exp(-(y-M)*(y-M)/2./S/S\n"); */
    if(ntry<MAXTRY){
      printf("%s ",ifile);
      printf("%"PRId32" A= %8.5e ",x+1,fit.a);
      printf("B= %8.5e ",fit.b - fit.a*reg.y0 );
      printf("N= %8.5e ",fit.n);
      printf("M= %8.5e ",fit.m+reg.y0);
      printf("S= %8.5e\n",fit.sigma);
    }else {
      printf("%s number of try is too much\n",ifile);
    }
    for(y=reg.y0-1;y<=reg.y1-1;++y) {
       i=y+1 ;
 /*    fprintf(stderr,"%ld %ld %f %f\n",x+1,y+1,v[y-(reg.y0-1)],
        (fit.a*i+fit.b+ - fit.a*reg.y0 + fit.n*
           exp(-(i-fit.m-reg.y0)*(i-fit.m-reg.y0)/2./fit.sigma/fit.sigma)));
 */
    }
  }

  fits_close_file(fits.fp,&status);
  exit(0);

}

/*=======================================================================*/
int check_command_line(int argc,char **argv,char **ifile,REGION *spd)
{

  if(argc==1){/* This is normal usage query  */
     print_usage(argv[0]);exit(0);}

  if(argc!=6){
    fprintf(stderr,"number of command line parameter is invalid\n");
    print_usage(argv[0]) ; return(-1) ;
  }
  *ifile = argv[1] ;
  region_input(argv[2],&(spd->w0),&(spd->w1),&(spd->wr));
  region_input(argv[3],&(spd->x0),&(spd->x1),&(spd->xr));
  region_input(argv[4],&(spd->y0),&(spd->y1),&(spd->yr));
  region_input(argv[5],&(spd->z0),&(spd->z1),&(spd->zr));

  if(spd->wr!=REG_POINT){
    fprintf(stderr,"w must be point\n");
    print_usage(argv[0]) ; return(-1) ;
  }
  if(spd->xr!=REG_LIST){
    fprintf(stderr,"x must be list\n");
    print_usage(argv[0]) ; return(-1) ;
  }
  if(spd->yr!=REG_REGION){
    fprintf(stderr,"y must be region\n");
    print_usage(argv[0]) ; return(-1) ;
  } 
  if(spd->zr!=REG_POINT){
    fprintf(stderr,"z must be point\n");
    print_usage(argv[0]) ; return(-1) ;
  }

  return(0);
}
/*=======================================================================*/
/* 켡ܥ˥Υեå(6) */
void fit_gaussian(double *v, int32_t n, GAUSSIAN *fit,int32_t flag)
{
double dA,dB,dN,dM,dS;

/* flag==1ΤȤͤϴ˷ޤäƤ롣 */
/* flag==0ΤȤʤˤ⤢餫Ϥʤ */

/*  */
  if(flag==0){
    fit->a = (v[n-1]-v[0])/(double)n ;
    fit->b = v[0] ;
    fit->m = (double)n / 2.0 ;
    fit->n = v[n/2] - (v[n-1]+v[0])/2.0 ;
    fit->sigma = 1.5 ;

/* ޤեå */
    dA=10.0 ; dB = 100.0 ; dN = 0.0 ; dM = 0.0 ; dS = 0.0 ;
    z_gaus5(v,n,&(fit->a),dA,&(fit->b),dB,&(fit->n),dN,
            &(fit->m),dM,&(fit->sigma),dS);
    dA=1.0 ; dB = 10.0 ; dN = 0.0 ; dM = 0.0 ; dS = 0.0 ;
    z_gaus5(v,n,&(fit->a),dA,&(fit->b),dB,&(fit->n),dN,
            &(fit->m),dM,&(fit->sigma),dS);
    dA=0.1 ; dB = 1.0 ; dN = 0.0 ; dM = 0.0 ; dS = 0.0 ;
    z_gaus5(v,n,&(fit->a),dA,&(fit->b),dB,&(fit->n),dN,
            &(fit->m),dM,&(fit->sigma),dS);

/* ˥ΤΥ٥Ĵ */
    dA=0.0 ; dB = 100.0 ; dN = 100.0 ; dM = 1.0 ; dS = 0.5 ;
    z_gaus5(v,n,&(fit->a),dA,&(fit->b),dB,&(fit->n),dN,
            &(fit->m),dM,&(fit->sigma),dS);
    dA=0.0 ; dB = 10.0 ; dN = 10.0 ; dM = 0.1 ; dS = 0.1 ;
    z_gaus5(v,n,&(fit->a),dA,&(fit->b),dB,&(fit->n),dN,
            &(fit->m),dM,&(fit->sigma),dS);
    dA=0.0 ; dB = 1.0 ; dN = 1.0 ; dM = 0.02 ; dS = 0.02 ;
    z_gaus5(v,n,&(fit->a),dA,&(fit->b),dB,&(fit->n),dN,
            &(fit->m),dM,&(fit->sigma),dS);
  }

/* ˺٥եå */
  dA=0.1 ; dB = 0.1 ; dN = 0.1 ; dM = 0.02 ; dS = 0.02 ;
  z_gaus5(v,n,&(fit->a),dA,&(fit->b),dB,&(fit->n),dN,
          &(fit->m),dM,&(fit->sigma),dS);


}
/*=======================================================================*/
/* 켡ܥ˥Υեå(5) */
double z_gaus5(double *v,int32_t n,
               double *A,double dA,double *B,double dB,double *N,double dN,
               double *M,double dM,double *S,double dS)
{
static double z0,z1;
int f;

  if(ntry>MAXTRY) return(0.);

  f=0;
  z0 = z_gaus4(v,n,*A,B,dB,N,dN,M,dM,S,dS);
  while(1){
    z1 = z_gaus4(v,n,*A+dA,B,dB,N,dN,M,dM,S,dS);
    if(z1<z0) {
      *A = *A+dA ; z0=z1 ; f= 1;
    }else {
      break ;
    }
  }
  if(f==0){
    while(1){
      z1 = z_gaus4(v,n,*A-dA,B,dB,N,dN,M,dM,S,dS);
      if(z1<z0) {
        *A = *A-dA ; z0=z1 ;
      }else {
        break ;
      }
    }
  }

  return(z0);
}
/*=======================================================================*/
/* 켡ܥ˥Υեå(4) */
double z_gaus4(double *v,int32_t n,
               double A,double *B,double dB,double *N,double dN,
               double *M,double dM,double *S,double dS)
{
static double z0,z1;
int f;

  if(ntry>MAXTRY) return(0.);

  f=0;
  z0 = z_gaus3(v,n,A,*B,N,dN,M,dM,S,dS);
  while(1){
    z1 = z_gaus3(v,n,A,*B+dB,N,dN,M,dM,S,dS);
    if(z1<z0) {
      *B = *B+dB ; z0=z1 ; f= 1;
    }else {
      break ;
    }
  }
  if(f==0){
    while(1){
      z1 = z_gaus3(v,n,A,*B-dB,N,dN,M,dM,S,dS);
      if(z1<z0) {
        *B = *B-dB ; z0=z1 ;
      }else {
        break ;
      }
    }
  }

  return(z0);
}
/*=======================================================================*/
/* 켡ܥ˥Υեå(3) */
double z_gaus3(double *v,int32_t n,
               double A,double B,double *N,double dN,double *M,double dM,
               double *S,double dS)
{
static double z0,z1;
int f;

  if(ntry>MAXTRY) return(0.);

  f=0; 
  z0 = z_gaus2(v,n,A,B,*N,M,dM,S,dS);
  while(1){
    z1 = z_gaus2(v,n,A,B,*N+dN,M,dM,S,dS);
    if(z1<z0) {
      *N = *N+dN ; z0=z1 ; f= 1;
    }else { 
      break ;
    }
  }
  if(f==0){
    while(1){
      z1 = z_gaus2(v,n,A,B,*N-dN,M,dM,S,dS);
      if(z1<z0) {
        *N = *N-dN ; z0=z1 ;
      }else { 
        break ;
      }
    }
  }
  return(z0);
}
/*=======================================================================*/
/* 켡ܥ˥Υեå(2) */
double z_gaus2(double *v,int32_t n,
               double A,double B,double N,double *M,double dM,
               double *S,double dS)
{
static double z0,z1;
int f;

  if(ntry>MAXTRY) return(0.);

  f=0; 
  z0 = z_gaus1(v,n,A,B,N,*M,S,dS);
  while(1){
/*  if(*M+dM>=n*2. || *M+dM<=-1.*n) z1=z0+100;  濴ڤ󤯤ϵʤ */ 
    if(*M+dM>=n || *M+dM<=-1.) z1=z0+100; /* ΰ賰ϵ */
    else z1 = z_gaus1(v,n,A,B,N,*M+dM,S,dS);
    if(z1<z0) {
      *M = *M+dM ; z0=z1 ; f= 1;
    }else { 
      break ;
    }
  }
  if(f==0){
    while(1){
/*    if(*M-dM>=n*2. || *M-dM<=-1.*n) z1=z0+100; * 濴ڤ󤯤ϵʤ */ 
      if(*M-dM>=n || *M-dM<=-1.) z1=z0+100; /* ΰ賰ϵ */
      else z1 = z_gaus1(v,n,A,B,N,*M-dM,S,dS);
      if(z1<z0) {
        *M = *M-dM ; z0=z1 ;
      }else { 
        break ;
      }
    }
  }
  
  return(z0);
}
/*=======================================================================*/
/* 켡ܥ˥Υեå(1) */
double z_gaus1(double *v,int32_t n,
               double A,double B,double N,double M,double *S,double dS)
{
static double z0,z1;
int f;

  if(ntry>MAXTRY) return(0.);

  f=0;
  z0 = zansa_gaus(v,n,A,B,N,M,*S);
  while(1){
    if(*S+dS<=0.5) z1 = z0+100. ;  /* SϥΥ */
    else if(*S+dS>=n*10.) z1 = z0+100. ;  /* Sn10ܤ礭Τ */
    else z1 = zansa_gaus(v,n,A,B,N,M,*S+dS);
    if(z1<z0) {
      *S = *S+dS ; z0=z1 ; f= 1;
    }else {
      break ;
    }
  }
  if(f==0){
    while(1){
      if(*S-dS<=0.5) z1 = z0 + 100.0 ;  /* SϥΥ */
      else if(*S-dS>=n*10.) z1 = z0 + 100.0 ; /* Sn10ܤ礭Τ */
      else z1 = zansa_gaus(v,n,A,B,N,M,*S-dS);
      if(z1<z0) {
        *S = *S-dS ; z0=z1 ;
      }else {
        break ;
      }
    }
  }

  return(z0);
}
/*=======================================================================*/
/* 켡ܥ˥λĺ */
double zansa_gaus(double *v,int32_t n,double A,double B,double N,double M,double S)
{
int i ;
static double z,w;

  if(ntry>MAXTRY) return(0.);

  z=0.0;
  for(i=0;i<n;++i){
    w = v[i] - (A*i + B + N* exp(-(i-M)*(i-M)/2./S/S));
    z += (w*w);
  }
  ntry++;
/*if(ntry%20000==0)
    printf("%e %f %f %f %f %f\n",z,A,B,N,M,S);
*/
  return(z);
}

