/*=======================================================================*/
/*  s_subch                                                              */
/*       chǰ                                                */
/*=======================================================================*/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<q_lib.h>
/*=======================================================================*/
void print_usage(char *);
int check_command_line(int,char **,char **,char **,int *);
/*=======================================================================*/
void print_usage(char *s)
{
char *ss;

  ss=strip_name(s);
  fprintf(stdout,
"NAME\n"
"       %s - subtract by specified channel.\n"
"\n"
"SYNOPSIS\n"
"       q_subch inp_file_name ch(or REF) out_file_name\n"
"       q_subch inp_file_name out_file_name\n"
"\n"
"DESCRIPTION\n"
"       COMICS image comes from 16 channels. Specified channel data is\n"
"       assumed as a reference data and %s subtract it from other data.n"
"       If no channel is specified, median of 16 channesl are used as \n"
"       reference data. When you use word REF as a channel, then \n"
"       median of 16 channel is outputed at all channels. If you subtract\n"
"       this image from original image, result is the same as the image \n"
"       with no channel specification\n"
,ss,ss);
}
/*=======================================================================*/
int main(int argc, char ** argv)
{
char *file,*out_file_name;
int ch;
FITS_DATA fits;
FITS_DATA ofits;
int status=0;
int x,y,z,w;
int i,j;
double w1,w2,aw,bufw[17];
int32_t h1,h2,al,bufl[17];

/* Check command line */
  if(check_command_line(argc,argv,&file,&out_file_name,&ch)!=0){
    fprintf(stdout,"Error @ check_command_line\n");exit(1);}

/* Open input file and out put files */
  if(openfits(&fits,file)!=0){ exit(1); }
  if(prep_readfits(&fits)!=0){ exit(1); }
  if(createfits(&ofits,out_file_name)!=0){ exit(1); }

/* Make new data type */
  ofits.nax=fits.nax ;
  ofits.naxes[0]=fits.naxes[0]; ofits.naxes[1]=fits.naxes[1];
  ofits.naxes[2]=fits.naxes[2]; ofits.naxes[3]=fits.naxes[3];
  if(fits.bp == DOUBLE_IMG || fits.bp == FLOAT_IMG ){
    ofits.bp = DOUBLE_IMG;
  }else if(fits.bp == BYTE_IMG || fits.bp == SHORT_IMG || fits.bp == LONG_IMG){
    ofits.bp = LONG_IMG ;
  }else{ fprintf(stdout,"Error bp\n");exit(1);}
  if(alloc_memory_for_data(&ofits)!=0) exit(1);

/* DOUBLE_IMG  LONG_IMG ʸ塢Ǥ */

/* Wrtie header  إåĤʤ
  if(write_head_img(&ofits)!=0){ exit(1); } */
/* Write header  إåĤ */
  if(convert_all_head(&fits,&ofits)!=0){
     fprintf(stdout,"Error @ convert_all_head"); exit(1); }

/* Calcuration */
  w1=w2=0.0;
  h1=h2=0;
  for(w=1;w<=ofits.naxes[3];++w){
  for(z=1;z<=ofits.naxes[2];++z){
    if(read_2d_data(&fits,z,w)!=0) { exit(1); }
    for(y=0;y<fits.naxes[1];++y){
    for(x=0;x<fits.naxes[0];++x){
      if(ofits.bp == DOUBLE_IMG) w1 = d_data(&fits, x, y);
      else                       h1 = int32_data(&fits, x, y);
      if(ch==0 || ch==17){
        for(i=1;i<=16;i++){
          if(ofits.bp == DOUBLE_IMG)bufw[i]=d_data(&fits,(i-1)*20+x%20, y);
          else                      bufl[i]=int32_data(&fits,(i-1)*20+x%20, y);
        }
        for(j=2;j<=16;j++){
          if(ofits.bp == DOUBLE_IMG) aw=bufw[j];
          else                       al=bufl[j];
          i=j-1;
          if(ofits.bp == DOUBLE_IMG) {
            while(i>0 && bufw[i]>aw){
              bufw[i+1]=bufw[i];
              i--;
            }
            bufw[i+1]=aw;
          }else{
            while(i>0 && bufl[i]>al){
              bufl[i+1]=bufl[i];
              i--;
            }
            bufl[i+1]=al;
          }
        }
        if(ofits.bp == DOUBLE_IMG) w2 = (bufw[7]+bufw[8])/2. ;  /* median */
        else                       h2 = (int32_t)(bufl[7]+bufl[8])/2.;/*median*/
        if(ch==17){
          if(ofits.bp == DOUBLE_IMG)
            ((double *)ofits.data)[x+y*ofits.naxes[0]] = w1 - w2 ;
          else
            ((int32_t *)ofits.data)[x+y*ofits.naxes[0]] = h1 - h2 ;
        }else{
          if(ofits.bp == DOUBLE_IMG)
            ((double *)ofits.data)[x+y*ofits.naxes[0]] = w2 ;
          else
            ((int32_t *)ofits.data)[x+y*ofits.naxes[0]] = h2 ;
        }
      }
      else{
        if(ofits.bp == DOUBLE_IMG){
          w2 = d_data(&fits, (ch-1)*20+x%20, y);
          ((double *)ofits.data)[x+y*ofits.naxes[0]] = w1 - w2 ;
        }else{
          h2 = int32_data(&fits, (ch-1)*20+x%20, y);
          ((int32_t *)ofits.data)[x+y*ofits.naxes[0]] = h1 - h2 ;
        }
      }
    }}
    if(write_2d_data(&ofits,z,w)!=0){exit(1);}
  }}


/* Close */
  fits_close_file(fits.fp,&status);
  fits_close_file(ofits.fp,&status);

  exit(0);
}
/*=======================================================================*/
int check_command_line(int argc,char ** argv ,char ** fname_1,char ** fname_2,
                       int *ch)
{
  if(argc==4 ){
    *fname_1 = argv[1] ;
    *fname_2 = argv[3] ;
    if(strcmp(argv[2],"REF")){
      sscanf(argv[2],"%d",ch);
    }else{
      *ch=0;
    }
    if( (*ch<0) || (*ch>17) ) {print_usage(argv[0]); return(1);}
  }else if(argc==3 ){
    *fname_1 = argv[1] ;
    *fname_2 = argv[2] ;
    *ch=17;
  }else{
    print_usage(argv[0]); return(1);
  }
  set_cmd_hist(argc,argv);
  return(0);
}

